"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

exports.__esModule = true;
exports["default"] = exports.modeEnums = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _udeskUi = require("udesk-ui");

var _excluded = ["agents", "valueMode", "value", "onChange", "disabled", "readOnly", "placeholder"];
var modeEnums;
exports.modeEnums = modeEnums;

(function (modeEnums) {
  modeEnums["Multiple"] = "multiple";
})(modeEnums || (exports.modeEnums = modeEnums = {}));

var AgentSelect = /*#__PURE__*/_react["default"].memo(function (props) {
  var _props$agents = props.agents,
      agents = _props$agents === void 0 ? [] : _props$agents,
      _props$valueMode = props.valueMode,
      valueMode = _props$valueMode === void 0 ? modeEnums.Multiple : _props$valueMode,
      value = props.value,
      _props$onChange = props.onChange,
      onChange = _props$onChange === void 0 ? function () {} : _props$onChange,
      disabled = props.disabled,
      readOnly = props.readOnly,
      placeholder = props.placeholder,
      restProps = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
  var options = (0, _react.useMemo)(function () {
    return agents.map(function (i) {
      return (0, _extends2["default"])({}, i, {
        value: i.id,
        label: i.nick_name
      });
    });
  }, [agents]);
  var isMulValue = (0, _react.useMemo)(function () {
    return valueMode === modeEnums.Multiple;
  }, [valueMode]);
  var selectValue = (0, _react.useMemo)(function () {
    var _formattedValueArr;

    // 无论单选多选都转换为数组做处理
    var formattedValueArr;

    if (typeof value === 'string' && value) {
      formattedValueArr = value.split(',');
    } else if (typeof value === 'number') {
      formattedValueArr = [value];
    } else if (Array.isArray(value)) {
      formattedValueArr = value;
    } else {
      formattedValueArr = [];
    } // value需要和option的值是同一种类型


    return (_formattedValueArr = formattedValueArr) == null ? void 0 : _formattedValueArr.map(function (value) {
      return value && isNaN(Number(value)) ? value : Number(value);
    });
  }, [isMulValue, value]);
  var selectData = (0, _react.useMemo)(function () {
    var selectOptions = options.filter(function (item) {
      return selectValue.includes(item.value);
    });
    return selectOptions;
  }, [isMulValue, selectValue]);
  var handleChange = (0, _react.useCallback)(function (value, options) {
    onChange(formatValueToString(value), options);
  }, []);
  var handleFilter = (0, _react.useCallback)(function (input, option) {
    return (option == null ? void 0 : option.nick_name.toLowerCase().indexOf(input.toLowerCase())) > -1 || (option == null ? void 0 : option.agent_name_pinyin.toLowerCase().indexOf(input.toLowerCase())) > -1;
  }, []);
  var readOnlyEle = (0, _react.useMemo)(function () {
    if (!selectData.length) {
      return /*#__PURE__*/_react["default"].createElement("span", null, "- -");
    }

    return selectData.map(function (item) {
      if (isMulValue) {
        return /*#__PURE__*/_react["default"].createElement(_udeskUi.Tag, {
          className: "custom-tag"
        }, (item == null ? void 0 : item.label) || '');
      }

      return /*#__PURE__*/_react["default"].createElement("span", null, (item == null ? void 0 : item.label) || '');
    });
  }, [selectData, isMulValue]);

  if (readOnly) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, readOnlyEle);
  }

  return /*#__PURE__*/_react["default"].createElement(_udeskUi.Select, (0, _extends2["default"])({}, restProps, {
    showSearch: true,
    allowClear: true,
    style: {
      width: '100%'
    },
    mode: valueMode,
    disabled: disabled,
    value: selectValue,
    placeholder: placeholder,
    onChange: handleChange,
    filterOption: handleFilter,
    options: options
  }));
});

AgentSelect.defaultProps = {
  disabled: false,
  readOnly: false,
  dropdownMatchSelectWidth: false,
  onChange: function onChange() {}
}; // 为了兼容原有数据结构,原数据格式为字符串(自定义字段使用)

function formatValueToString(value) {
  if (Array.isArray(value)) {
    return value.join(',');
  }

  return value;
}

var _default = AgentSelect;
exports["default"] = _default;